unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    SpeedButton1: TSpeedButton;
    Label1: TLabel;
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure Inic_Nave(Sender:TObject);
  end;

type
  TNave = object
    N_Cima  : Boolean;
    N_Baixo : Boolean;
    N_Esquerda : Boolean;
    N_Direita  : Boolean;
    N_Sprite   : TImage;
    N_Tempo    : TTimer;
    N_Atirou   : Boolean;
    N_Velocidade : Integer;
end;

type
  TInimigo = object
  I_Sprite : TShape;
end;

var
  Form1: TForm1;
  Nave    : TNave;
  Inimigo : TInimigo;
  Temp    : Word;
  LastLR  : Integer;
  LastUD  : Integer;

implementation

{$R *.DFM}

procedure TForm1.Inic_Nave(Sender:TObject);
var panel10,panel11 : integer;
    p10,p11 : Integer;
begin
  with Nave do
       begin
         if N_Sprite.Left <= 0 then
            N_Sprite.Left := 0;
         if (N_Sprite.Left + N_Sprite.Width) >= Form1.ClientWidth then
            N_Sprite.Left := Form1.ClientWidth - N_Sprite.Width;

         if N_Sprite.Top <= 0 then
            N_Sprite.Top := 0;
         if (N_Sprite.Top + N_Sprite.Height) >= Form1.ClientHeight then
            N_Sprite.Top := Form1.ClientHeight - N_Sprite.Height;

panel10 := Inimigo.I_Sprite.top + Inimigo.I_Sprite.height;
panel11 := Inimigo.I_Sprite.left + Inimigo.I_Sprite.width;

p10 := N_Sprite.Top + N_Sprite.height;
p11 := N_Sprite.left + N_Sprite.width;


if (Inimigo.I_Sprite.left <= p11)
and(Panel11>=N_Sprite.left)
and(Inimigo.I_Sprite.top<=p10)
and(panel10>=N_Sprite.top) then
begin
  if N_Cima then
     N_Cima := False
     else
       if N_Baixo then
          N_Baixo := False
       else
          if N_Esquerda then
             N_Esquerda := False
          else
            if N_Direita then
               N_Direita := False;

end;


        // if (N_Sprite.Top < Inimigo.I_Sprite.Top + Inimigo.I_Sprite.Height) then
             //N_Cima := False;

         if N_Cima then
            N_Sprite.Top := N_Sprite.Top - N_Velocidade;
         if N_Baixo then
            N_Sprite.Top := N_Sprite.Top + N_Velocidade;
         if N_Direita then
            N_Sprite.Left := N_Sprite.Left + N_Velocidade;
         if N_Esquerda then
            N_Sprite.Left := N_Sprite.Left - N_Velocidade;

       end;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  with Nave do
       begin
         N_Sprite := TImage.Create(Self);
         N_Sprite.Picture.LoadFromFile('Nave2.bmp');
         N_Sprite.Parent := Self;
         N_Sprite.Transparent := True;
         N_Sprite.Top  := Form1.ClientHeight div 2;
         N_Sprite.Left := 0;//Form1.ClientWidth div 2;
         N_Sprite.AutoSize := True;

         N_Tempo := TTimer.Create(Self);
         N_Tempo.Interval := 1;
         N_Tempo.OnTimer := Inic_Nave;

         N_Cima     := False;
         N_Baixo    := False;
         N_Esquerda := False;
         N_Direita  := False;
         N_Atirou   := False;
         N_Velocidade := 1;
       end;
  with Inimigo do
       begin
         I_Sprite := TShape.Create(Self);
         I_Sprite.Parent := Self;
         I_Sprite.Left := 100;
         I_Sprite.Top  := 100;
       end;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
{  if Key = vk_right then
     Nave.N_Direita := True;
  if Key = vk_left then
     Nave.N_Esquerda := True;
  if Key = vk_up then
     Nave.N_Cima := True;
  if Key = vk_down then
     Nave.N_Baixo := True;
  Canvas.TextOut(10,10,inttoStr(key));
}
  temp := key; key := 0; { stop further processing }
  case temp of
       vk_left   : begin
                     Nave.N_Esquerda := true; lastlr:=1;
                   end;
       vk_right  : begin
                     Nave.N_Direita  := true; lastlr:=2;
                   end;
{up}   vk_up     : begin
                     Nave.N_Cima := true; lastud:=3;
                   end;
{dn}   vk_down   : begin
                     Nave.N_Baixo := true; lastud:=4;
                   end;
      else
        key:=temp; { enable further processing }
    end;






  Form1.Repaint;
  Canvas.TextOut(50,10,'Nave LEFT = ' + inttoStr(Nave.N_Sprite.Left));
  Canvas.TextOut(50,30,'Inim LEFT = ' + inttoStr(Inimigo.I_Sprite.Left));
  Canvas.TextOut(50,50,'Resultado = ' + inttoStr(Nave.N_Sprite.Left - Inimigo.I_Sprite.Left));
  Canvas.TextOut(50,70,'Inim WIDT = ' + inttoStr(Inimigo.I_Sprite.Width));
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  with Nave do
       begin
         if Key in [37..40] then
            begin
              N_Cima     := False;
              N_Baixo    := False;
              N_Direita  := False;
              N_Esquerda := False;
            end;
       end;
end;

end.
